package com.ejie.ab79.dao.preguntasRespuestas;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.REST.servicioWeb.FicheroRespuestaExpediente;
import com.ejie.ab79.model.preguntasRespuestas.FicherosAdjExp;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * FicherosAdjExpDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class FicherosAdjExpDaoImpl implements FicherosAdjExpDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDFICHEROADJEXP", "IDRESPUESTAEXPEDIENTE",
			"TIPOFICHEROADJUNTO", "NOMBREFICHEROADJUNTO", "IDDOCUMENTOSUBIDO", "FICHEROADJUNTO", "FECHAREGISTRO",
			"USUARIOREGISTRO", "FECHAULTMODIFICACION", "USUARIOULTMODIFICACION" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<FicherosAdjExp> rwMap = new RowMapper<FicherosAdjExp>() {
		public FicherosAdjExp mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			FicherosAdjExp ficheroAdjExp = new FicherosAdjExp();
			ficheroAdjExp.setIdFicheroAdjExp(resultSet.getInt("IDFICHEROADJEXP"));
			ficheroAdjExp.setIdRespuestaExpediente(resultSet.getInt("IDRESPUESTAEXPEDIENTE"));
			ficheroAdjExp.setTipoFicheroAdjunto(resultSet.getInt("TIPOFICHEROADJUNTO"));
			ficheroAdjExp.setNombreFicheroAdjunto(resultSet.getString("NOMBREFICHEROADJUNTO"));
			ficheroAdjExp.setIdDocumentoSubido(resultSet.getInt("IDDOCUMENTOSUBIDO"));
			ficheroAdjExp.setOidPid(resultSet.getString("OIDPID"));
			ficheroAdjExp.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			ficheroAdjExp.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			ficheroAdjExp.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			ficheroAdjExp.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));
			ficheroAdjExp.setIdDocumentoMovil(resultSet.getString("IDDOCUMENTOMOVIL"));

			return ficheroAdjExp;
		}
	};

	private RowMapper<FicherosAdjExp> rwMapPK = new RowMapper<FicherosAdjExp>() {
		public FicherosAdjExp mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new FicherosAdjExp(resultSet.getInt("IDFICHEROADJEXP"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<FicherosAdjExp>> rwMapJerarquia = new RowMapper<JerarquiaDto<FicherosAdjExp>>() {
		public JerarquiaDto<FicherosAdjExp> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			FicherosAdjExp ficheroAdjExp = new FicherosAdjExp();
			ficheroAdjExp.setIdFicheroAdjExp(resultSet.getInt("IDFICHEROADJEXP"));
			ficheroAdjExp.setIdRespuestaExpediente(resultSet.getInt("IDRESPUESTAEXPEDIENTE"));
			ficheroAdjExp.setTipoFicheroAdjunto(resultSet.getInt("TIPOFICHEROADJUNTO"));
			ficheroAdjExp.setNombreFicheroAdjunto(resultSet.getString("NOMBREFICHEROADJUNTO"));
			ficheroAdjExp.setIdDocumentoSubido(resultSet.getInt("IDDOCUMENTOSUBIDO"));
			ficheroAdjExp.setOidPid(resultSet.getString("OIDPID"));
			ficheroAdjExp.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			ficheroAdjExp.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			ficheroAdjExp.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			ficheroAdjExp.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));
			ficheroAdjExp.setIdDocumentoMovil(resultSet.getString("IDDOCUMENTOMOVIL"));

			JerarquiaDto<FicherosAdjExp> jerarquia = new JerarquiaDto<FicherosAdjExp>();
			jerarquia.setModel(ficheroAdjExp);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<FicheroRespuestaExpediente> rwMapFicherosREST = new RowMapper<FicheroRespuestaExpediente>() {
		public FicheroRespuestaExpediente mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			FicheroRespuestaExpediente ficheroRespuestaExpediente = new FicheroRespuestaExpediente();
			ficheroRespuestaExpediente.setIdFichero(resultSet.getInt("idfichero"));
			ficheroRespuestaExpediente.setIdPreguntaExpediente(resultSet.getInt("idpreguntaexpediente"));
			ficheroRespuestaExpediente.setTipoFichero(resultSet.getInt("tipofichero"));
			ficheroRespuestaExpediente.setNombreFichero(resultSet.getString("NOMBREFICHEROADJUNTO"));
			ficheroRespuestaExpediente.setOid(resultSet.getString("OIDPID"));

			return ficheroRespuestaExpediente;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the FicherosAdjExp table.
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @return FicherosAdjExp
	 */
	public FicherosAdjExp add(FicherosAdjExp ficherosadjexp) {
		String query = "INSERT INTO FICHEROS_ADJ_EXP (ID_FICHERO_ADJ_EXP, ID_RESPUESTA_EXPEDIENTE, TIPO_FICHERO_ADJUNTO, ID_DOCUMENTO_SUBIDO, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (S_AB7924T00.NEXTVAL,?,?,?,sysdate,?)";
		this.jdbcTemplate.update(query, ficherosadjexp.getIdRespuestaExpediente(),
				ficherosadjexp.getTipoFicheroAdjunto(), ficherosadjexp.getIdDocumentoSubido(),
				ficherosadjexp.getUsuarioRegistro());
		return ficherosadjexp;
	}

	/**
	 * Updates a single row in the FicherosAdjExp table.
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @return FicherosAdjExp
	 */
	public FicherosAdjExp update(FicherosAdjExp ficherosadjexp) {
		String query = "UPDATE FICHEROS_ADJ_EXP SET ID_RESPUESTA_EXPEDIENTE=?, TIPO_FICHERO_ADJUNTO=?, ID_DOCUMENTO_SUBIDO=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=? WHERE ID_FICHERO_ADJ_EXP=?";
		this.jdbcTemplate.update(query, ficherosadjexp.getIdRespuestaExpediente(),
				ficherosadjexp.getTipoFicheroAdjunto(), ficherosadjexp.getIdDocumentoSubido(),
				ficherosadjexp.getUsuarioUltmodificacion(), ficherosadjexp.getIdFicheroAdjExp());
		return ficherosadjexp;
	}

	/**
	 * Finds a single row in the FicherosAdjExp table.
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @return FicherosAdjExp
	 */
	@Transactional(readOnly = true)
	public FicherosAdjExp find(FicherosAdjExp ficherosadjexp) {
		String query = "SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP, t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO, t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM FICHEROS_ADJ_EXP t1, DOCUMENTOS_SUBIDOS t2 WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) AND t1.ID_FICHERO_ADJ_EXP = ?  ";

		List<FicherosAdjExp> ficherosadjexpList = this.jdbcTemplate.query(query, this.rwMap,
				ficherosadjexp.getIdFicheroAdjExp());
		return (FicherosAdjExp) DataAccessUtils.uniqueResult(ficherosadjexpList);
	}

	@Override
	public List<FicherosAdjExp> findFicheros() {
		String query = "SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP, t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO, t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM FICHEROS_ADJ_EXP t1, DOCUMENTOS_SUBIDOS t2 WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ORDER BY t1.TIPO_FICHERO_ADJUNTO ASC ";

		return this.jdbcTemplate.query(query, this.rwMap);
	}

	/**
	 * Removes a single row in the FicherosAdjExp table.
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @return
	 */
	public void remove(FicherosAdjExp ficherosadjexp) {
		String query = "DELETE FROM FICHEROS_ADJ_EXP WHERE ID_FICHERO_ADJ_EXP=?";
		this.jdbcTemplate.update(query, ficherosadjexp.getIdFicheroAdjExp());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<FicherosAdjExp> getMultiple(FicherosAdjExp filterFicherosAdjExp, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterFicherosAdjExp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, FicherosAdjExp.class, params,
				"ID_FICHERO_ADJ_EXP");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the FicherosAdjExp table.
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<FicherosAdjExp>
	 */
	@Transactional(readOnly = true)
	public List<FicherosAdjExp> findAll(FicherosAdjExp ficherosadjexp, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP,t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append("FROM FICHEROS_ADJ_EXP t1, DOCUMENTOS_SUBIDOS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(ficherosadjexp);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, FicherosAdjExpDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<FicherosAdjExp>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the FicherosAdjExp table using like.
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<FicherosAdjExp>
	 */
	@Transactional(readOnly = true)
	public List<FicherosAdjExp> findAllLike(FicherosAdjExp ficherosadjexp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP,t1.ID_DOCUMENTO_MOVIL ID_DOCUMENTO_MOVIL, t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append("FROM FICHEROS_ADJ_EXP t1, DOCUMENTOS_SUBIDOS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(ficherosadjexp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, FicherosAdjExpDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<FicherosAdjExp>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<FicheroRespuestaExpediente> findFicherosREST(Integer idInspeccion) {
		String query = "SELECT t1.id_fichero_adj_exp idfichero, t2.id_pregunta_expediente idpreguntaexpediente, t1.tipo_fichero_adjunto tipofichero, t4.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t4.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO FROM ficheros_adj_exp t1, preguntas_expediente t2, respuestas_expediente t3, DOCUMENTOS_SUBIDOS t4 WHERE t1.ID_DOCUMENTO_SUBIDO = t4.ID_DOCUMENTO_SUBIDO(+) AND t2.id_pregunta_expediente = t3.id_pregunta_expediente AND t3.id_respuesta_expediente = t1.id_respuesta_expediente AND t2.id_inspeccion = ?";

		return (List<FicheroRespuestaExpediente>) this.jdbcTemplate.query(query, this.rwMapFicherosREST, idInspeccion);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the FicherosAdjExp table.
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(FicherosAdjExp ficherosadjexp) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM FICHEROS_ADJ_EXP t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(ficherosadjexp);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the FicherosAdjExp table using like.
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(FicherosAdjExp ficherosadjexp, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM FICHEROS_ADJ_EXP t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(ficherosadjexp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of FicherosAdjExp selected for rup_table
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosAdjExp>>
	 */
	@Override
	public List<TableRowDto<FicherosAdjExp>> reorderSelection(FicherosAdjExp ficherosadjexp,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP,t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FICHERO_ADJUNTO FICHEROADJUNTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM FICHEROS_ADJ_EXP t1, DOCUMENTOS_SUBIDOS t2 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(ficherosadjexp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, FicherosAdjExp.class,
				filterParamList, "ID_FICHERO_ADJ_EXP");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<FicherosAdjExp>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            FicherosAdjExp
	 * @param searchParams
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosAdjExp>>
	 */
	@Override
	public List<TableRowDto<FicherosAdjExp>> search(FicherosAdjExp filterParams, FicherosAdjExp searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP,t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FICHERO_ADJUNTO FICHEROADJUNTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM FICHEROS_ADJ_EXP t1, DOCUMENTOS_SUBIDOS t2 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, FicherosAdjExp.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_FICHERO_ADJ_EXP");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<FicherosAdjExp>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterficherosadjexp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(FicherosAdjExp filterficherosadjexp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP,t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FICHERO_ADJUNTO FICHEROADJUNTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM FICHEROS_ADJ_EXP t1, DOCUMENTOS_SUBIDOS t2 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterficherosadjexp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, FicherosAdjExp.class,
				query, params, "ID_FICHERO_ADJ_EXP");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical FicherosAdjExp table.
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<FicherosAdjExp>>
	 */
	@Override
	public List<JerarquiaDto<FicherosAdjExp>> findAllLikeJerarquia(FicherosAdjExp filterFicherosAdjExp,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP,t1.ID_DOCUMENTO_MOVIL ID_DOCUMENTO_MOVIL, t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO,t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FICHERO_ADJUNTO FICHEROADJUNTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM FICHEROS_ADJ_EXP t1 ");
		List<String> from = new ArrayList<String>();
		from.add("FICHEROS_ADJ_EXP");
		from.add("DOCUMENTOS_SUBIDOS");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterFicherosAdjExp, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_FICHERO_ADJ_EXP", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					FicherosAdjExpDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(FicherosAdjExp filterFicherosAdjExp, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM FICHEROS_ADJ_EXP t1 ");
		List<String> from = new ArrayList<String>();
		from.add("FICHEROS_ADJ_EXP");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterFicherosAdjExp, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_FICHERO_ADJ_EXP",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<FicherosAdjExp>>
	 */
	@Override
	public List<TableRowDto<FicherosAdjExp>> findAllChild(FicherosAdjExp filterFicherosAdjExp,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM FICHEROS_ADJ_EXP t1 ");
		List<String> from = new ArrayList<String>();
		from.add("FICHEROS_ADJ_EXP");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterFicherosAdjExp, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_FICHERO_ADJ_EXP",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<FicherosAdjExp>(this.rwMapPK, "ID_FICHERO_ADJ_EXP"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the FicherosAdjExp entity
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(FicherosAdjExp ficherosadjexp) {

		StringBuilder where = new StringBuilder(FicherosAdjExpDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (ficherosadjexp != null && ficherosadjexp.getIdFicheroAdjExp() != null) {
			where.append(" AND t1.ID_FICHERO_ADJ_EXP = ?");
			params.add(ficherosadjexp.getIdFicheroAdjExp());
		}
		if (ficherosadjexp != null && ficherosadjexp.getIdRespuestaExpediente() != null) {
			where.append(" AND t1.ID_RESPUESTA_EXPEDIENTE = ?");
			params.add(ficherosadjexp.getIdRespuestaExpediente());
		}
		if (ficherosadjexp != null && ficherosadjexp.getTipoFicheroAdjunto() != null) {
			where.append(" AND t1.TIPO_FICHERO_ADJUNTO = ?");
			params.add(ficherosadjexp.getTipoFicheroAdjunto());
		}
		if (ficherosadjexp != null && ficherosadjexp.getNombreFicheroAdjunto() != null) {
			where.append(" AND t1.NOMBRE_FICHERO_ADJUNTO = ?");
			params.add(ficherosadjexp.getNombreFicheroAdjunto());
		}
		if (ficherosadjexp != null && ficherosadjexp.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(ficherosadjexp.getFechaRegistro());
		}
		if (ficherosadjexp != null && ficherosadjexp.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(ficherosadjexp.getUsuarioRegistro());
		}
		if (ficherosadjexp != null && ficherosadjexp.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(ficherosadjexp.getFechaUltmodificacion());
		}
		if (ficherosadjexp != null && ficherosadjexp.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(ficherosadjexp.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the FicherosAdjExp entity
	 *
	 * @param ficherosadjexp
	 *            FicherosAdjExp Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(FicherosAdjExp ficherosadjexp, Boolean startsWith) {

		StringBuilder where = new StringBuilder(FicherosAdjExpDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		where.append(" AND t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+)");

		if (ficherosadjexp != null && ficherosadjexp.getIdFicheroAdjExp() != null) {
			where.append(" AND t1.ID_FICHERO_ADJ_EXP = ?");
			params.add(ficherosadjexp.getIdFicheroAdjExp());
		}
		if (ficherosadjexp != null && ficherosadjexp.getIdRespuestaExpediente() != null) {
			where.append(" AND t1.ID_RESPUESTA_EXPEDIENTE = ?");
			params.add(ficherosadjexp.getIdRespuestaExpediente());
		}
		if (ficherosadjexp != null && ficherosadjexp.getTipoFicheroAdjunto() != null) {
			where.append(" AND t1.TIPO_FICHERO_ADJUNTO = ?");
			params.add(ficherosadjexp.getTipoFicheroAdjunto());
		}
		if (ficherosadjexp != null && ficherosadjexp.getNombreFicheroAdjunto() != null) {
			where.append(" AND UPPER(t1.NOMBRE_FICHERO_ADJUNTO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(ficherosadjexp.getNombreFicheroAdjunto().toUpperCase() + "%");
			} else {
				params.add("%" + ficherosadjexp.getNombreFicheroAdjunto().toUpperCase() + "%");
			}
			where.append(" AND t1.NOMBRE_FICHERO_ADJUNTO IS NOT NULL");
		}
		if (ficherosadjexp != null && ficherosadjexp.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(ficherosadjexp.getFechaRegistro());
		}
		if (ficherosadjexp != null && ficherosadjexp.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(ficherosadjexp.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + ficherosadjexp.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (ficherosadjexp != null && ficherosadjexp.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(ficherosadjexp.getFechaUltmodificacion());
		}
		if (ficherosadjexp != null && ficherosadjexp.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(ficherosadjexp.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + ficherosadjexp.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	@Override
	public List<FicherosAdjExp> findFicherosByIdRespuesta(Integer idRespuestaExpediente) {
		String query = "SELECT t1.ID_FICHERO_ADJ_EXP IDFICHEROADJEXP, t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.TIPO_FICHERO_ADJUNTO TIPOFICHEROADJUNTO, t2.NOMBRE_DOCUMENTO NOMBREFICHEROADJUNTO, t2.OID_PID OIDPID, t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM FICHEROS_ADJ_EXP t1, DOCUMENTOS_SUBIDOS t2 WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO(+) AND t1.ID_RESPUESTA_EXPEDIENTE = ? ";

		return this.jdbcTemplate.query(query, this.rwMap, idRespuestaExpediente);
	}

}
